package it.unitn.lingprogmod1.esercitazione2;

import java.util.Collections;
import java.util.LinkedList;

    public class Mazzo extends LinkedList<Carta> {


        public Mazzo() { // opzione A
            for (int i = 1; i <= 2; i++) {// ripeto due volte il ciclo di creazione
                for (Valore v : Valore.values()) {
                    for (Seme s: Seme.values()) {
                        Carta c = new Carta(v, s);
                        this.add(c);
                    }
                }
            }
        }
        /*
        public Mazzo() { // opzione B
            for (String v : valore) {
                for (String s: seme) {
                    Carta c = new Carta(v, s);
                    this.add(c);
                    this.add(c);
                }
            }
        }
        */
        /**
         * Costruttore che, dato un mazzo, ne costruisce un secondo costituito dalle prime n carte
         * @param n numero di carte che compongono in mazzo creato
         * @param m mazzo da cui copiare le prime n carte
         */
        public Mazzo(int n, Mazzo m) {
            for (int i=0;i<n;i++) {
                this.add(m.get(i));
            }
        }

        void mescola() {
            Collections.shuffle(this);
        }

        @Override
        public String toString() {
            String s="Mazzo {\n";
            for (Carta c: this) {
                s = s + c.toString()+"\n";
            }
            s=s+'}';
            return s;
        }

        /**
         * Metodo che controlla se nel mazzo ci sono due carte uguali
         * @return la (prima) carta duppia trovata, o null se non vi sono carte doppie
         */
        public Carta trovaPrimaDoppia(){
            int n=this.size();
            for (int i=0; i<n-1;i++) {
                Carta c1=this.get(i);
                for (int j=i+1; j<n; j++) {
                    Carta c2=this.get(j);
                    if (c1.confronta(c2)) {
                        // stampa di controllo, da levare dopo il debugging
                        System.out.println("found at "+i+" "+j+" : "+c1.toString());
                        return c1;
                    }
                }
            }
            return null;
        }

        /**
         * main di test
         * @param a
         */
        public static void main(String a[]){
            Mazzo m=new Mazzo();
            m.mescola();
            m.trovaPrimaDoppia();
        }
    }
